<?php

function coral_defender_drush_command() {
  $items = array();

  $items['coral add'] = array(
    'callback' => 'coral_defender_drush_add',
    'description' => "Adds a host name to redirect to the Coral CDN if it is the referrer.",
  );
  $items['coral delete'] = array(
    'callback' => 'coral_defender_drush_delete',
    'description' => "Removes a host name from the tables so referrers from that host will NOT be redirected.",
  );
  return $items;
}

function coral_defender_drush_help($section) {
  switch ($section) {
    case 'drush:migrate':
      return dt("Runs the migration on your site to re-map file paths (arguments: from site dir, to site dir - don't include /sites or any slashes.)  Example: drush migrate www.example.com www.mynewsite.com");
  }
}

function coral_defender_drush_add() {
  $args = func_get_args();
  $host_name = $args[0];
  if (empty($host_name)) {
    drush_print('Please enter a host name. Example: drush coral add drupal.org   See drush help coral add for more info');
  }
  elseif (stristr($host_name,'http://') !== FALSE) {
    drush_print('Please enter a host name without the http://. Example: drush coral add drupal.org   See drush help coral add for more info');
  }
  else {
	module_load_include('inc', 'coral_defender', 'coral_defender.common');
    _coral_defender_set(0, $host_name);
    drush_print('Host redirect has been saved.');
  }
}

function coral_defender_drush_delete() {
  $args = func_get_args();
  $host_name = $args[0];
  if (empty($host_name)) {
    drush_print('Please enter a host name. Example: drush coral delete drupal.org   See drush help coral add for more info');
  }
  elseif (stristr($host_name,'http://') !== FALSE) {
    drush_print('Please enter a host name without the http://. Example: drush coral delete drupal.org   See drush help coral add for more info');
  }
  else {
    module_load_include('inc', 'coral_defender', 'coral_defender.common');
    $result = _coral_defender_find($host_name);
    if(db_affected_rows() == 1){
      $r = db_fetch_object($result);
      _coral_defender_delete($r->rid);
      drush_print('Host redirect deleted.');
    }
  }
}