<?php


function coral_defender_admin() {
  $result = pager_query('SELECT rid, host FROM {coral_defender} ORDER BY host', 50);
  $found = FALSE;
  while ($r = db_fetch_object($result)) {
    $found = TRUE;
    $rows[] = array(
      $r->host,
      array('data' => l(t('edit'), 'admin/settings/coral_defender/edit/'. $r->rid)),
      array('data' => l(t('delete'), 'admin/settings/coral_defender/delete/'. $r->rid)),
    );
  }
  $header = array(t('Host'), array('data' => t('Operations'), 'colspan' => '3'));
  
  if ($found) {
    $output .= '<p>'. theme('table', $header, $rows) .'</p>';
  }
  else {
    $output .= '<p>'. t('No entries found.') .'</p>';
  }
  
  $output .= '<p>'. l(t('Add New Referer Redirect'), 'admin/settings/coral_defender/new') .'</p>';
  
  $output .= theme('pager');
  
  return $output;
  
}

function coral_defender_edit_form(&$form_state, $rid = 0) {
  module_load_include('inc', 'coral_defender', 'coral_defender.common');
  $host_value = '';
  if ($rid != 0) {
    $form['rid'] = array(
      '#type' => 'hidden',
      '#value' => $rid,
    );
    $result = _coral_defender_get($rid);
    $temp_host_array = db_fetch_array($result);
    $host_value = $temp_host_array['host'];
  }

  $form['host'] = array(
    '#type' => 'textfield',
    '#title' => t('From'),
    '#description' => t('Enter a host name to redirect from (example: digg.com)'),
    '#default_value' => $host_value,
  );
      
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
  );
  
  return $form;
}

function coral_defender_edit_form_submit($form, &$form_state) {
  module_load_include('inc', 'coral_defender', 'coral_defender.common');
  $host = $form_state['values']['host'];
  $rid = $form_state['values']['rid'];
  _coral_defender_set($rid, $host);
  drupal_set_message(t('Host redirect has been saved.'));
  drupal_goto('admin/settings/coral_defender');
}

function coral_defender_edit_form_validate($form, &$form_state) {
  $host = $form_state['values']['host'];
  if (trim($host) == '') {
    form_set_error('path', t('You must enter a <strong>host name</strong> like www.example.com or example.com.'));
  }
  //check that the from url does not include the http://.
  elseif (stristr($host, 'http://')) {
    form_set_error('path', t('Please do not include the <strong>http://</strong>.'));
  }
}

function coral_defender_delete_form(&$form_state, $rid = 0) {
  $form['rid'] = array(
    '#type' => 'hidden',
    '#value' => check_plain($rid),
  );
  
  return confirm_form($form, t('Are you sure you want to delete this referer host redirect?'), 'admin/settings/coral_defender');
}

function coral_defender_delete_form_submit($form, &$form_state) {
  module_load_include('inc', 'coral_defender', 'coral_defender.common');
  _coral_defender_delete($form_state['values']['rid']);
  drupal_set_message(t('Referer host redirect item has been deleted.'));
  drupal_goto('admin/settings/coral_defender');
}